'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _yylibUi = require('yylib-ui');

var _immutable = require('immutable');

var _lodash = require('lodash');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./style/index.less');

var _YYEnumSelect = require('../enum/YYEnumSelect');

var _YYEnumSelect2 = _interopRequireDefault(_YYEnumSelect);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 定义高级查询
 */
var React = require('react');

var _require = require('antd'),
    Row = _require.Row,
    Col = _require.Col,
    Button = _require.Button,
    Icon = _require.Icon,
    Form = _require.Form;

var FormItem = Form.Item;

// var NccSearchCondition = require('./NccSearchCondition')
var PropTypes = _yylibUi.YYClass.PropTypes;
var field = _yylibUi.YYClass.field;
var Constant = require('../search/Constant');
var url = require('../search/Resturl');

var FormItemType = require('../widgets/FormItemType');
function noop() {}
//定义META
var uiMeta = {
    name: 'ncc-advanceSearch',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'advance-search', PropTypes.string, false, '样式名前缀'), field('gutter', 0, PropTypes.number, false, '栅格间隔'), field('span', 3, PropTypes.number, false, '显示搜索条件数量'), field('align', 'top', PropTypes.oneOf(['top', 'middle', 'bottom']), false, 'flex 布局下的垂直对齐方式：top middle bottom'), field('justify', 'start', PropTypes.oneOf(['start', 'end', 'center', 'space-around', 'space-between']), false, 'flex 布局下的水平排列方式：start end center space-around space-between'), field('expandText', '收起', PropTypes.string, false, '展开时显示的文本'), field('collapseText', '展开', PropTypes.string, false, '折叠时显示的文本'), field('expand', false, PropTypes.bool, false, '是否展开所有查询列表'), field('onExpandOrCollapse', null, PropTypes.func, false, "当展开|折叠时的回调，传递参数：'expand'|'collapse'"), field('onSearchClick', noop, PropTypes.func, false, '查询回调')]
};
var NccAdvanceSearch = _yylibUi.YYClass.create({
    uiMeta: uiMeta,
    getInitialState: function getInitialState() {
        return {
            expand: this.props.expand == true || this.props.expand == 'true',
            _dataSource: [],
            _dataItem: [],
            _visible: false,
            cellErrors: {},
            _schemeId: null,
            _schemeName: null,
            _schemeList: [],
            totalSpan: 18
        };
    },
    componentWillMount: function componentWillMount() {
        // const {findUI} = this.context;
        this.procDataItem();
        // this.procSchemeQuery();
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        if (!(0, _immutable.is)((0, _immutable.fromJS)(this.props.children), (0, _immutable.fromJS)(nextProps.children))) {
            this.procDataItem(nextProps.children);
        }
    },
    procDataItem: function procDataItem(value) {
        var children = this.props.children;

        var _dataItem = [],
            _dataSource = [];
        _dataItem.push({
            uitype: "advanceSearchCondition",
            uititle: "库存组织",
            title: "库存组织",
            uikey: "pk_org",
            dataIndex: "pk_org",
            fieldtype: "object",
            inputtype: "input",
            oper: [],
            required: true,
            inputprops: {
                refinfokey: "600027-0001Z01000000001BVPC",
                refName: "库存组织",
                refId: "2c9485d2713f740e01715a1fadad028c"
            },
            nid: "nid_1590392378653_2"
        });
        _dataItem.push({
            uitype: "advanceSearchCondition",
            uititle: "商品编码",
            title: "商品编码",
            uikey: "pk_code",
            dataIndex: "pk_org",
            fieldtype: "object",
            inputtype: "input",
            required: true,
            oper: [],
            inputprops: {
                refinfokey: "600027-0001Z01000000001BVPC",
                refName: "库存组织",
                refId: "2c9485d2713f740e01715a1fadad028c"
            },
            nid: "nid_1590392378653_2"
        });
        _dataItem.push({
            uitype: "advanceSearchCondition",
            uititle: "商品编码",
            title: "商品编码",
            uikey: "pk_code",
            dataIndex: "pk_org",
            fieldtype: "object",
            inputtype: "input",
            required: true,
            oper: [],
            inputprops: {
                refinfokey: "600027-0001Z01000000001BVPC",
                refName: "库存组织",
                refId: "2c9485d2713f740e01715a1fadad028c"
            },
            nid: "nid_1590392378653_2"
        });
        _dataItem.push({
            uitype: "advanceSearchCondition",
            uititle: "商品名称",
            title: "商品名称",
            uikey: "pk_name",
            dataIndex: "pk_org",
            fieldtype: "object",
            inputtype: "input",
            oper: [],
            required: true,
            inputprops: {
                refinfokey: "600027-0001Z01000000001BVPC",
                refName: "库存组织",
                refId: "2c9485d2713f740e01715a1fadad028c"
            },
            nid: "nid_1590392378653_2"
        });
        // React.Children.map(value || children, item => {
        //     if (React.isValidElement(item)) {
        //         let inputprops = item.props.inputprops ? _.clone(item.props.inputprops) : {};
        //         // 下拉选择特殊处理
        //         if (inputprops && (item.props.inputtype === FormItemType.select)) {
        //             const items = item.props.children ? _.clone(item.props.children) : [];
        //             const options = [];
        //             if (items && items.length > 0) {
        //                 _.forEach(items, function (item) {
        //                     var option = {};
        //                     option.value = item.value;
        //                     option.text = item.text || item.children;
        //                     options.push(option);
        //                 });
        //             }
        //             inputprops.items = options;
        //         }
        //         _dataItem.push({
        //             key: item.props.uikey,
        //             fieldkey: item.props.fieldkey || item.props.uikey,
        //             title: item.props.title,
        //             fieldtype: item.props.fieldtype,
        //             inputtype: item.props.inputtype,
        //             inputprops: inputprops,
        //             oper: item.props.oper || [],
        //             enableOrder: item.props.enableOrder === undefined ? false : item.props.enableOrder,
        //             enableSearch: item.props.enableSearch === undefined ? true : item.props.enableSearch,
        //             hidden: item.props.hidden === undefined ? false : item.props.hidden,
        //             required: item.props.required === undefined ? false : item.props.required,
        //             readonly: item.props.readonly === undefined ? false : item.props.readonly,
        //             presetFunc: item.props.funcId ? {
        //                 funcId: item.props.funcId,
        //                 funcCode: item.props.funcCode,
        //                 funcName: item.props.funcName
        //             } : null
        //         });
        //     }
        // });
        this.setState({
            _dataItem: _dataItem,
            _dataSource: _dataItem.slice(0, this.props.span)
        });
    },

    _createSpan: function _createSpan() {
        return React.createElement(
            'div',
            { className: this.className('collapse') },
            React.createElement(
                'span',
                { onClick: this._onChange },
                this.state.expand ? this.props.expandText : this.props.collapseText
            ),
            React.createElement(Icon, { type: this.state.expand ? "up" : "down", classnames: this.className('collapse-icon') })
        );
    },
    _onChange: function _onChange() {
        var _this = this;

        this.setState({
            expand: !this.state.expand,
            _dataSource: this.state._dataItem,
            totalSpan: this.state.totalSpan / this.props.span == 6 ? 24 : 18
        }, function () {
            if (!_this.state.expand) {
                _this.setState({
                    _dataSource: _this.state._dataItem.slice(0, _this.props.span)
                });
            }
        });
        if ((0, _lodash.isFunction)(this.props.onExpandOrCollapse)) {
            this.props.onExpandOrCollapse(this.state.expand ? 'expand' : 'collapse');
        }
    },
    handleSearchClick: function handleSearchClick() {
        var onSearchClick = this.props.onSearchClick;
        var _dataSource = this.state._dataSource;

        var cb = _dataSource.map(function (item) {
            return {
                key: item.key,
                logic: item.oper[0],
                value: item.value,
                inputtype: item.inputtype
            };
        });
        if (this.validate() === true) {
            onSearchClick(cb);
        }
    },
    handleClearClick: function handleClearClick() {
        var dataSource = [];
        this.state._dataSource.map(function (item) {
            delete item.value;
            dataSource.push(item);
        });
        this.setState({ _dataSource: dataSource });
    },
    handleSaveScheme: function handleSaveScheme() {
        this.setState({ _visible: true });
    },
    procSchemeUpdate: function procSchemeUpdate() {
        var _this2 = this;

        var _props = this.props,
            areaid = _props.areaid,
            uiRunMode = _props.uiRunMode;
        var _state = this.state,
            _dataSource = _state._dataSource,
            _schemeId = _state._schemeId,
            _schemeName = _state._schemeName,
            _schemeList = _state._schemeList;

        var REF_BASE_URL = window.EnvConfig.REF_BASE_URL;
        var otherProps = { isdevelop: false, isquickqs: false };
        if (uiRunMode === 'design') {
            otherProps['isdevelop'] = true;
        }
        if (!!!areaid) {
            _yylibUi.YYMessage.error('方案编号没有配置');
            return;
        }
        if (_schemeList.length === 0) {
            _yylibUi.YYMessage.error('还不存在方案，请新建方案');
            return;
        } else if (!!!_schemeId) {
            _yylibUi.YYMessage.error('选择要保存的方案');
            return;
        }
        ajax.postJSONEx(REF_BASE_URL + SchemeUpdate, {
            "busiParamJson": JSON.stringify(_extends({}, otherProps, {
                areaid: areaid,
                name: _schemeName,
                pk_ncc_queryscheme: _schemeId,
                renderobj4web: _dataSource
            })),
            "sysParamJson": { pagecs: Cookies.get("cookiets") }
        }, function (result) {
            if (result.success === true) {
                _yylibUi.YYMessage.success('保存方案成功');
                _this2.procSchemeQuery();
            }
        });
    },
    procSchemeQuery: function procSchemeQuery() {
        var _this3 = this;

        var areaid = this.props.areaid;

        var REF_BASE_URL = window.EnvConfig.REF_BASE_URL;
        if (!!!areaid) {
            _yylibUi.YYMessage.error('方案编号没有配置');
            return;
        }
        ajax.postJSONEx(REF_BASE_URL + SchemeQuery, {
            "busiParamJson": JSON.stringify({ areaid: areaid }),
            "sysParamJson": { pagecs: Cookies.get("cookiets") }
        }, function (result) {
            if (result.success === true) {
                _this3.setState({ _schemeList: result.data || [] });
            }
        });
    },
    handleUpdateScheme: function handleUpdateScheme() {
        this.procSchemeUpdate();
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },

    // 查询条件api
    renderCompareCol: function renderCompareCol(value, rowData, index, dataIndex) {
        var options = [];
        _.forEach(rowData.oper || [], function (subItem) {
            options.push(React.createElement(
                _yylibUi.YYOption,
                { key: subItem, value: subItem },
                Constant.oper[subItem]
            ));
        });
        return React.createElement(
            _yylibUi.YYSelect,
            {
                defaultValue: (rowData.oper || [])[0],
                value: Constant.oper[value],
                key: rowData.field,
                onChange: this.onCellChange.bind(this, rowData, dataIndex),
                disableClear: true
            },
            options
        );
    },
    renderDataCol: function renderDataCol(value, rowData, index, dataIndex) {
        var cont = React.createElement(_yylibUi.YYInput, { value: '', onChange: this.onCellChange.bind(this, rowData, dataIndex) });
        var inputprops = rowData.inputprops || {};
        var presetFunc = rowData.presetFunc || {};
        var serverUrl = inputprops && inputprops.serverUrl ? inputprops.serverUrl : url.REFER_SEVER_URL;
        // 有预置函数时删除置空提示
        if (presetFunc && inputprops && inputprops.placeholder) {
            delete inputprops.placeholder;
        }
        switch (rowData.inputtype) {
            case FormItemType.input:
                // 文本框
                cont = React.createElement(_yylibUi.YYInput, _extends({}, inputprops, {
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.date:
                // 日期
                if (rowData.logic === 'bt') {
                    cont = React.createElement(_yylibUi.YYRangePicker, _extends({}, inputprops, {
                        value: value,
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                } else {
                    cont = React.createElement(_yylibUi.YYDatePicker, _extends({}, inputprops, {
                        value: value,
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                }
                break;
            case FormItemType.select:
                // 下拉选择
                cont = React.createElement(_yylibUi.YYSelect, _extends({}, inputprops, {
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.inputrefer:
                //  参照
                cont = React.createElement(_yylibUi.YYReferInput, _extends({}, inputprops, {
                    serverUrl: serverUrl,
                    condition: inputprops.condition,
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.switch:
                // 开关
                cont = React.createElement(_yylibUi.YYSwitch, _extends({}, inputprops, {
                    checked: value === null ? inputprops.defaultChecked : value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.enumselect:
                // 档案枚举
                if (!value && inputprops.multiple === true) {
                    value = [];
                }
                cont = React.createElement(_YYEnumSelect2.default, _extends({}, inputprops, {
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.number:
                // 数值框
                cont = React.createElement(_yylibUi.YYInputNumber, _extends({}, inputprops, {
                    value: value,
                    type: 'number',
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.currency:
                // 金额框
                cont = React.createElement(_yylibUi.YYInputNumber, _extends({}, inputprops, {
                    value: value,
                    type: 'currency',
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.autoselect:
                // 自动匹配
                cont = React.createElement(_yylibUi.YYAutoSelect, _extends({}, inputprops, {
                    serverUrl: serverUrl,
                    condition: inputprops.condition,
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
        }
        return React.createElement(
            'div',
            null,
            cont
        );
    },
    onCellChange: function onCellChange(rowData, dataIndex, value) {
        var _dataSource = this.state._dataSource;

        var _value = undefined;
        if (value != null && value != undefined) {
            _value = value.target ? value.target.value : value;
        }
        _dataSource[_.findIndex(_dataSource, { uikey: rowData.uikey })][dataIndex] = _value;
        this.setState({ _date: Date.now(), cellErrors: {} });
    },
    validate: function validate() {
        var _dataSource = this.state._dataSource;
        var cellErrors = this.state.cellErrors;

        _.forEach(_dataSource, function (item) {
            if (item.required === true) {
                if (item.value === null || item.value === undefined) {
                    cellErrors[item.uikey] = {};
                }
            }
        });
        this.setState({ _date: Date.now() });
        if (_.isEmpty(cellErrors)) {
            return true;
        } else {
            return false;
        }
    },
    render: function render() {
        var _this4 = this;

        var _state2 = this.state,
            _state2$_dataItem = _state2._dataItem,
            _dataItem = _state2$_dataItem === undefined ? [] : _state2$_dataItem,
            _state2$_dataSource = _state2._dataSource,
            _dataSource = _state2$_dataSource === undefined ? [] : _state2$_dataSource,
            totalSpan = _state2.totalSpan;

        var span = this._createSpan();
        return React.createElement(
            'div',
            _extends({}, this.props, { className: this.className() }),
            React.createElement(
                Row,
                { className: this.className() + '-condition', type: 'flex' },
                _dataSource.map(function (v, index) {
                    return React.createElement(
                        Col,
                        { span: totalSpan / _this4.props.span, className: _this4.className() + '-condition-item' },
                        React.createElement(
                            'span',
                            { className: _this4.className() + '-condition-label' },
                            v.title,
                            ' :'
                        ),
                        React.createElement(
                            'div',
                            { className: _this4.className() + '-condition-item-input' },
                            _this4.renderDataCol(v.value, v, index, 'value')
                        )
                    );
                }),
                React.createElement(
                    Col,
                    { className: this.className() + '-action', span: 6 },
                    React.createElement(
                        _yylibUi.YYButton,
                        { type: 'primary', onClick: this.handleSearchClick },
                        '\u67E5\u8BE2'
                    ),
                    React.createElement(
                        _yylibUi.YYButton,
                        { onClick: this.handleClearClick },
                        '\u91CD\u7F6E'
                    ),
                    React.createElement(
                        _yylibUi.YYButton,
                        { type: 'success', onClick: this.handleUpdateScheme },
                        '\u4FDD\u5B58\u65B9\u6848'
                    ),
                    span
                )
            )
        );
    }
});

module.exports = NccAdvanceSearch;