'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('yylib-ui'),
    YYClass = _require.YYClass,
    YYTable = _require.YYTable,
    YYSelect = _require.YYSelect,
    YYOption = _require.YYOption,
    YYInput = _require.YYInput,
    YYIcon = _require.YYIcon,
    YYRangePicker = _require.YYRangePicker,
    YYDatePicker = _require.YYDatePicker,
    YYReferInput = _require.YYReferInput,
    YYSwitch = _require.YYSwitch,
    YYInputNumber = _require.YYInputNumber,
    YYAutoSelect = _require.YYAutoSelect;

var _require2 = require('antd'),
    Col = _require2.Col,
    Row = _require2.Row;
// import YYEnumSelect from '../../business/enum/YYEnumSelect';


var Constant = require('../search/Constant');
var url = require('../search/Resturl');
var FormItemType = require('../widgets/FormItemType');

var NccSearchCondition = YYClass.create({
    getDefaultProps: function getDefaultProps() {
        return {
            rootPrefixCls: 'advance-search',
            dataSource: []
        };
    },
    getInitialState: function getInitialState() {
        return {
            ellErrors: {}
        };
    },
    getClassName: function getClassName() {
        var rootPrefixCls = this.props.rootPrefixCls;

        return (0, _classnames2.default)(rootPrefixCls + '-condition');
    },
    renderCompareCol: function renderCompareCol(value, rowData, index, dataIndex) {
        var options = [];
        _lodash2.default.forEach(rowData.oper || [], function (subItem) {
            options.push(_react2.default.createElement(
                YYOption,
                { key: subItem, value: subItem },
                Constant.oper[subItem]
            ));
        });
        return _react2.default.createElement(
            YYSelect,
            {
                defaultValue: (rowData.oper || [])[0],
                value: Constant.oper[value],
                key: rowData.field,
                onChange: this.onCellChange.bind(this, rowData, dataIndex),
                disableClear: true
            },
            options
        );
    },
    renderDataCol: function renderDataCol(value, rowData, index, dataIndex) {
        var cont = _react2.default.createElement(YYInput, { value: '', onChange: this.onCellChange.bind(this, rowData, dataIndex) });
        var inputprops = rowData.inputprops || {};
        var presetFunc = rowData.presetFunc || {};
        var serverUrl = inputprops && inputprops.serverUrl ? inputprops.serverUrl : url.REFER_SEVER_URL;
        // 有预置函数时删除置空提示
        if (presetFunc && inputprops && inputprops.placeholder) {
            delete inputprops.placeholder;
        }
        switch (rowData.inputtype) {
            case FormItemType.input:
                // 文本框
                cont = _react2.default.createElement(YYInput, _extends({}, inputprops, {
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.date:
                // 日期
                if (rowData.logic === 'bt') {
                    cont = _react2.default.createElement(YYRangePicker, _extends({}, inputprops, {
                        value: value,
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                } else {
                    cont = _react2.default.createElement(YYDatePicker, _extends({}, inputprops, {
                        value: value,
                        onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                }
                break;
            case FormItemType.select:
                // 下拉选择
                cont = _react2.default.createElement(YYSelect, _extends({}, inputprops, {
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.inputrefer:
                //  参照
                cont = _react2.default.createElement(YYReferInput, _extends({}, inputprops, {
                    serverUrl: serverUrl,
                    condition: inputprops.condition,
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.switch:
                // 开关
                cont = _react2.default.createElement(YYSwitch, _extends({}, inputprops, {
                    checked: value === null ? inputprops.defaultChecked : value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            // case FormItemType.enumselect: // 档案枚举
            //     if (!value && inputprops.multiple === true) {
            //         value = [];
            //     }
            //     cont = (
            //         <YYEnumSelect
            //             {...inputprops}
            //             value={value}
            //             onChange={this.onCellChange.bind(this, rowData, dataIndex)}/>
            //     );
            //     break;
            case FormItemType.number:
                // 数值框
                cont = _react2.default.createElement(YYInputNumber, _extends({}, inputprops, {
                    value: value,
                    type: 'number',
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.currency:
                // 金额框
                cont = _react2.default.createElement(YYInputNumber, _extends({}, inputprops, {
                    value: value,
                    type: 'currency',
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
            case FormItemType.autoselect:
                // 自动匹配
                cont = _react2.default.createElement(YYAutoSelect, _extends({}, inputprops, {
                    serverUrl: serverUrl,
                    condition: inputprops.condition,
                    value: value,
                    onChange: this.onCellChange.bind(this, rowData, dataIndex) }));
                break;
        }
        return _react2.default.createElement(
            'div',
            null,
            cont
        );
    },
    onCellChange: function onCellChange(rowData, dataIndex, value) {
        var dataSource = this.props.dataSource;

        var _value = undefined;
        if (value != null && value != undefined) {
            _value = value.target ? value.target.value : value;
        }
        dataSource[_lodash2.default.findIndex(dataSource, { id: rowData.id })][dataIndex] = _value;
        this.setState({ _date: Date.now(), cellErrors: {} });
    },
    onRowDel: function onRowDel(value, rowData, index) {
        var dataSource = this.props.dataSource;

        dataSource.splice(_lodash2.default.findIndex(dataSource, { id: rowData.id }), 1);
        this.setState({ _date: Date.now() });
    },
    validate: function validate() {
        var dataSource = this.props.dataSource;
        var cellErrors = this.state.cellErrors;

        _lodash2.default.forEach(dataSource, function (item) {
            if (item.required === true) {
                if (item.value === null || item.value === undefined) {
                    cellErrors[item.id] = {};
                }
            }
        });
        this.setState({ _date: Date.now() });
        if (_lodash2.default.isEmpty(cellErrors)) {
            return true;
        } else {
            return false;
        }
    },
    render: function render() {
        var _this = this;

        var _props = this.props,
            dataSource = _props.dataSource,
            span = _props.span;

        return _react2.default.createElement(
            Row,
            { style: { type: 'flex' }, className: this.getClassName() },
            dataSource.map(function (v, index) {
                return _react2.default.createElement(
                    Col,
                    { span: 24 / span },
                    _this.renderDataCol(v.value, v, index, 'value')
                );
            })
        );
    }
});
module.exports = NccSearchCondition;